include \masm32\include\masm32rt.inc

floatx$ MACRO arg, digitfactor:=<1000>
  push digitfactor
  push offset arg
  call floatx
  EXITM <eax>
ENDM

.data?
flBuffer	db 20 dup(?)

.code
x1000	REAL4 1000.0
  ; bits		54321098
  MbDown64 =	10000111b
  MbNear64 =	10000011b
floatx_s: 
floatx proc uses edi pArg, digits
  stack equ <dword ptr [esp]>
  mov edi, offset flBuffer
  push edi			; save offset flBuffer
  push 256*MbDown64+255	; create a slot with control word
  fnstcw word ptr [esp+2]	; save a copy to hiword
  fldcw word ptr [esp]	; set new control word
  mov edx, pArg
  ffree st(7)
  fld REAL8 PTR [edx]	; 123.007
  push edx
  cmp byte ptr [edx+7], 0
  .if Sign?
	fchs
	mov al, "-"	; handle a negative number
	stosb
  .endif
  fist stack	; stack=123
  fisub stack	; ST0=0.456
  invoke dwtoa, [esp+4], edi
  add edi, len(edi)
  mov byte ptr [esp+5], MbNear64
  fldcw word ptr [esp+4]	; set new control word
  pop edx
  push digits
  fimul stack		; ST0=7.xxx
  fiadd stack		; ST0=1007.xxx
  fistp stack
  pop eax
  invoke dwtoa, eax, edi
  mov byte ptr [edi], "."	; overwrite the leading "1"
  fldcw word ptr [esp+2]	; set old control word
  pop edx
  pop eax			; return start of buffer
  ret
floatx endp
floatx_endp:
	
r8a	REAL8	12.3456
r8b	REAL8	1234.56
r8c	REAL8	1234567.89012345678
r8d	REAL8	-0.00123456789	; negative number
r8e	REAL8	1.23456
r8f	REAL8	-123.456	; negative number

start:	mov ebx, esp
	print floatx$(r8a), 13, 10
	print floatx$(r8b), 13, 10
	print floatx$(r8c, 100000000), 13, 10
	print floatx$(r8d, 10000000), 13, 10
	print floatx$(r8e), 13, 10
	print floatx$(r8f), 13, 10
	sub ebx, esp
	inkey str$(ebx), " stack diff", 13, 10
	exit

end start

OPT_Wait 	0
OPT_Tmp2Asm	1
